<div class="mt-4 blocks float-right feed-details">
  <div class="row">
    <div class="col-md-10 d-flex">
      <div class="text-dark font-weight-bold mb-1">{{dataLayoutContent.title}}</div>
    <ejs-tooltip id="tooltip" content={{dataLayoutContent.title}}><em class="fa fa-info-circle ml-1 info-icon"></em></ejs-tooltip></div>
    <div class="text-danger text-right font-weight-bold ml-16">*Required</div>
  </div>
  <hr class="bg-light customHR mt-2">
  <div class="mr-4 pl-0 mb-3 mt-4 col-md-10 choose-layer-setting" [ngClass]="editparam ? 'hide-layer-selection': ''">
    <div class="row ml-2">
    <span class="text-danger font-weight-bold ml-11">* </span>
    <p class="text-left text-dark font-weight-bold mb-1">{{dataLayoutContent.tableMapTitle}}</p>
  </div>
    <span *ngFor="let granularityCheckOption of granularityCheckOptions" class="mr-4 mb-2 radio-btn-margin">
      <ejs-radiobutton label="{{granularityCheckOption}}" name="granularity" cssClass="custom-radio-btn"
        #granularity="ngModel" [(ngModel)]="activeGranularity" (change)="granularityChange(granularityCheckOption)"
        value="{{granularityCheckOption}}" [ngClass]="granularity.disabled? 'no-pointer' : ''">
      </ejs-radiobutton>
    </span>

    <div class="row mt-3">
      <div class="col-md-6 mr-4">
        <div class="row ml-2">
          <span class="text-danger font-weight-bold ml-11">*</span>
          <p class="text-left text-dark font-weight-bold mb-2">{{dataLayoutContent.dataLayer}}</p>
        </div>
        <ejs-dropdownlist name="businessLayer" #businessLayer="ngModel" [(ngModel)]="activeLayerId"
          [dataSource]="storageTypes" [fields]="sourceStorageFields" class="mr-2 custom-ddl" cssClass="e-outline"
          (change)="dataLayerChange($event)">
        </ejs-dropdownlist>
      </div>
      <div class="col-md-5">
        <p class="text-left text-dark font-weight-bold mb-2">{{dataLayoutContent.dataObject}}</p>
        <div *ngIf="activeGranularity===granularityCheckOptions[0]">
          <ejs-dropdownlist name="selectObject" [dataSource]="objectList" (change)="objectChange($event)"
            [fields]="objectFields" cssClass="e-outline" class="mr-6 custom-ddl"
            [ngClass]="isObjectNameRefAlreadyExist ? 'error-control-highlight' : ''">
          </ejs-dropdownlist>
        </div>
        <ejs-textbox *ngIf="activeGranularity===granularityCheckOptions[1]" name="objectName" #objectName="ngModel"
          [(ngModel)]="tblObjectName" (change)="checkDuplicateTableName()" class="custom-textbox" required
          [ngClass]="isObjectNameAlreadyExist || isObjectNameRefAlreadyExist ? 'error-control-highlight' : ''"
          cssClass="e-outline">
        </ejs-textbox>
      </div>
    </div>
  </div>
  <!-- <div class="row mb-2">
    <div class="col-md-11">
      <div class="blocks ml-2 mt-2 mr-4">
        <button class="actionButton btn btn-primary float-right">{{dataLayoutContent.editTable}}</button>
      </div>
    </div>
  </div> -->
  <div class="row">
    <div class="col-md-11 ml-2">
      <div class="container-fluid float-right mt-3 mb-4 mr-2">
        <form #dataLayoutForm="ngForm">
          <ejs-grid #grid [dataSource]="dataLayoutDetails"  class="onboarding-grid"
          [editSettings]="editing" height="345" [allowRowDragAndDrop]="false"
          [allowResizing]="false" (actionBegin)="actionBegin($event)" (actionComplete)="actionComplete($event)"
          (headerCellInfo)="headerCellInfo($event)" [allowTextWrap]="true"> 
            <e-columns>
              <e-column field="at_nm" headerText="{{dataLayoutContent.headerText.columnName}}" isPrimary="true"
                width=130>
                <ng-template #editTemplate>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <ejs-dropdownlist name="at_nm" #at_nm [(ngModel)]="dataLayoutDetail.at_nm" required
                      (select)="onColumnHeaderSelection($event)"
                      (beforeOpen)="onColumnHeaderDropdownOpen(dataLayoutDetail.at_nm)"
                      (close)="onColumnHeaderDropdownClose(dataLayoutDetail.at_nm)" [dataSource]="fileHeaderList"
                      [ngClass]="columnNameEmpty ? 'error-control-highlight' : ''" popupHeight="300px">
                    </ejs-dropdownlist>
                  </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                    <label>{{dataLayoutDetail.at_nm}}</label>
                  </div>
                </ng-template>
              </e-column>
              <e-column field="etl_nm" headerText="{{dataLayoutContent.headerText.stdColumnName}}" width=130>
                <ng-template #editTemplate>
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                  <input class="e-input e-field" name="etl_nm" #etl_nm [(ngModel)]="dataLayoutDetail.etl_nm" required
                    type="text" maxlength="50" />
                  </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <label>{{dataLayoutDetail.etl_nm}}</label>
                  </div>
                </ng-template>
              </e-column>
              <e-column field="is_mandatory" headerText="{{dataLayoutContent.headerText.required}}" width=100>
                <ng-template #editTemplate>
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                  <ejs-dropdownlist name="is_mandatory" #is_mandatory [(ngModel)]="dataLayoutDetail.is_mandatory"
                    [dataSource]="requiredList" [fields]="{ text: 'requiredType', value: 'requiredType'}"
                    popupHeight="300px">
                  </ejs-dropdownlist>
                  </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <label>{{dataLayoutDetail.is_mandatory}}</label>
                  </div>
                </ng-template>
              </e-column>
              <e-column field="data_type" headerText="{{dataLayoutContent.headerText.dataType}}" width=120>
                <ng-template #editTemplate>
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                  <ejs-dropdownlist name="data_type" (change)="dataLayoutDetail.prec = setIntialPrecisionValue($event,dataLayoutDetail.prec);
                                    dataLayoutDetail.scale = setIntialScaleValue($event,dataLayoutDetail.scale);
                                    dataLayoutDetail.dt_frmt = setIntialFormatValue($event);" #data_type
                    [(ngModel)]="dataLayoutDetail.data_type" [dataSource]="dataTypeList"
                    [fields]="{ text: 'datatype', value: 'datatype', category: 'datacategory' }" popupHeight="300px">
                  </ejs-dropdownlist>
                </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <label>{{dataLayoutDetail.data_type}}</label>
                  </div>
                </ng-template>
              </e-column>
              <e-column field="prec" headerText="{{dataLayoutContent.headerText.precision}}" width=100>
                <ng-template #template let-dataLayoutDetail>
                  <label>{{precisionDisplayText(dataLayoutDetail.data_type,dataLayoutDetail.prec)}}</label>
                </ng-template>
                <ng-template #editTemplate>
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                  <ejs-dropdownlist name="txtPrec" #txtPrec *ngIf="!precisionStatus(dataLayoutDetail.data_type)"
                    [(ngModel)]="dataLayoutDetail.prec" value="0" [dataSource]="defaultValueList"
                    [fields]="{ text: 'dispText', value: 'actualValue' }"
                    [disabled]="!precisionStatus(dataLayoutDetail.data_type)"></ejs-dropdownlist>
                  <ejs-numerictextbox name="prec" #prec required *ngIf="precisionStatus(dataLayoutDetail.data_type)"
                    format="n0" [(ngModel)]="dataLayoutDetail.prec" min="0"
                    [max]="precMaxLength(dataLayoutDetail.data_type)">
                  </ejs-numerictextbox>
                  </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <label>{{dataLayoutDetail.prec}}</label>
                  </div>
                </ng-template>
              </e-column>
              <e-column field="scale" headerText="{{dataLayoutContent.headerText.scale}}" width=100>
                <ng-template #template let-dataLayoutDetail>
                  <label>{{scaleDisplayText(dataLayoutDetail.data_type,dataLayoutDetail.scale)}}</label>
                </ng-template>
                <ng-template #editTemplate>
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                  <ejs-dropdownlist name="txtScale" #txtScale *ngIf="!scaleStatus(dataLayoutDetail.data_type)"
                    [(ngModel)]="dataLayoutDetail.scale" value="0" [dataSource]="defaultValueList"
                    [fields]="{ text: 'dispText', value: 'actualValue' }"
                    [disabled]="!scaleStatus(dataLayoutDetail.data_type)"></ejs-dropdownlist>
                  <ejs-numerictextbox name="scale" #scale required *ngIf="scaleStatus(dataLayoutDetail.data_type)"
                    format="n0" [(ngModel)]="dataLayoutDetail.scale"
                    [max]="scaleMaxLength(dataLayoutDetail.data_type,dataLayoutDetail.prec)" min="0">
                  </ejs-numerictextbox>
                  </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <label>{{dataLayoutDetail.scale}}</label>
                  </div>
                </ng-template>
              </e-column>
              <e-column field="dt_frmt" headerText="{{dataLayoutContent.headerText.format}}" width=120>
                <ng-template #template let-dataLayoutDetail>
                  <label>{{formatDisplayText(dataLayoutDetail.data_type)}}</label>
                </ng-template>
                <ng-template #editTemplate>
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                  <ejs-combobox name="dt_frmt" [disabled]="enableFormatControl(dataLayoutDetail.data_type)" #data_type
                    [(ngModel)]="dataLayoutDetail.dt_frmt" [dataSource]="dateFormatList" popupHeight="300px">
                  </ejs-combobox>
                  </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <label>{{dataLayoutDetail.dt_frmt}}</label>
                    </div>
                </ng-template>
              </e-column>
              <e-column field="column_width" *ngIf="isFixedWidthFile"
                headerText="{{dataLayoutContent.headerText.width}}" width=100>
                <ng-template #template let-dataLayoutDetail>
                  <label>{{dataLayoutDetail.column_width}}</label>
                </ng-template>
                <ng-template #editTemplate>
                  
                  <div *ngIf="activeGranularity===granularityCheckOptions[1]">
                  <ejs-numerictextbox name="colWidth" #colWidth required format="n0"
                    [(ngModel)]="dataLayoutDetail.column_width" max="100" min="0">
                  </ejs-numerictextbox>
                  </div>
                  <div *ngIf="activeGranularity===granularityCheckOptions[0]">
                    <label>{{dataLayoutDetail.column_width}}</label>
                    </div>
                </ng-template>
              </e-column>
            </e-columns>
          </ejs-grid>
          <!-- <span class="d-flex float-right margin-top-42 mr-2" id="customPagerTemplate">
            <span class="text-dark ml-5 mr-2 mt-1 pt-1">Results Per Page</span>
            <span class="mt-1">
              <ejs-dropdownlist name="pageSize" cssClass="e-outline"
                [dataSource]="['All', '5', '10', '20', '30', '50', '100']" value="5" (change)="changePageSize($event)"
                width="75px">
              </ejs-dropdownlist>
            </span>
          </span> -->
        </form> 
      </div>
    </div>
  </div>
  <!-- <span id="columnChooserTemplateDL" class=" mr-0 top-minus-8">
    <button class="iconButton btn btn-primary" data-ripple="true" aria-label="Choose Columns To be Displayed">
      <img src="assets/images/novartis/column.svg" alt="Choose Columns" />
    </button>
  </span> -->
</div>